diff -Naur linux-2.4.2-orig/drivers/usb/ov511.c linux/drivers/usb/ov511.c
--- linux-2.4.2-orig/drivers/usb/ov511.c	Fri Mar  2 03:21:10 2001
+++ linux/drivers/usb/ov511.c	Tue Mar 27 22:24:30 2001
@@ -1623,10 +4176,20 @@
 	int aPackNum[10];
 	struct ov511_frame *frame;
 	unsigned char *pData;
-	int iPix;
+	int iPix, data_size, pn, num, offset;
+	struct timeval *ts;
 
 	PDEBUG (4, "Moving %d packets", urb->number_of_packets);
 
+	/* OV518+ has no packet numbering */
+	if (ov511->bridge == BRG_OV518PLUS) {
+		pn = 0;
+		data_size = ov511->packet_size;
+	} else {
+		pn = 1;
+		data_size = ov511->packet_size - 1;
+	}
+
 	for (i = 0; i < urb->number_of_packets; i++) {
 		int n = urb->iso_frame_desc[i].actual_length;
 		int st = urb->iso_frame_desc[i].status;
@@ -1636,7 +4199,8 @@
 
 		cdata = urb->transfer_buffer + urb->iso_frame_desc[i].offset;
 
-		aPackNum[i] = n ? cdata[ov511->packet_size - 1] : -1;
+		if (pn)
+			aPackNum[i] = n ? cdata[ov511->packet_size - 1] : -1;
 
 		if (!n || ov511->curframe == -1)
 			continue;
@@ -1645,44 +4209,114 @@
 			PDEBUG(2, "data error: [%d] len=%d, status=%d", i, n, st);
 
 		frame = &ov511->frame[ov511->curframe];
-		
+
 		/* SOF/EOF packets have 1st to 8th bytes zeroed and the 9th
 		 * byte non-zero. The EOF packet has image width/height in the
-		 * 10th and 11th packets. The 9th bit is given as follows:
+		 * 10th and 11th bytes. The 9th byte is given as follows:
 		 *
 		 * bit 7: EOF
 		 *     6: compression enabled
 		 *     5: 422/420/400 modes
 		 *     4: 422/420/400 modes
 		 *     3: 1
-		 *     2: snapshot bottom on
+		 *     2: snapshot button on
 		 *     1: snapshot frame
 		 *     0: even/odd field
 		 */
 
-		/* Check for SOF/EOF packet */
-		if ((cdata[0] | cdata[1] | cdata[2] | cdata[3] | 
-		     cdata[4] | cdata[5] | cdata[6] | cdata[7]) ||
-		     (~cdata[8] & 0x08))
-			goto check_middle;
+#if 0
+		{
+			int d;
+			/* Print all data */
+			for (d = data_size; d < data_size; d += 16) {
+				info("%4x: %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x", d,
+					cdata[d], cdata[d+1], cdata[d+2], cdata[d+3],
+					cdata[d+4], cdata[d+5], cdata[d+6], cdata[d+7],
+					cdata[d+8], cdata[d+9], cdata[d+10], cdata[d+11],
+					cdata[d+12], cdata[d+13], cdata[d+14], cdata[d+15]);
+			}
+		}
+#endif
+
+		if (printph) {
+			info("packet header: %x %x %x %x %x %x %x %x %x %x %x %x",
+				cdata[0], cdata[1], cdata[2], cdata[3], cdata[4], cdata[5],
+				cdata[6], cdata[7], cdata[8], cdata[9], cdata[10], cdata[11]);
+		}
+
+		if (ov511->bridge == BRG_OV518PLUS) {
+			int trailer = data_size - 9;
+
+			// Could a packet be both SOF and EOF?
+
+			if (compress)
+				trailer -= 64;
+
+			if (printph) {
+				info("trailer: %x %x %x %x %x %x %x %x", 
+					cdata[trailer], cdata[trailer+1], cdata[trailer+2], cdata[trailer+3],
+					cdata[trailer+4], cdata[trailer+5], cdata[trailer+6], cdata[trailer+7]);
+			}
+
+			/* A false positive here is likely, until OVT gives me
+			 * the definitive SOF/EOF format */
+			if (!(cdata[0] | cdata[1] | cdata[2] | cdata[3] |
+			      cdata[5]) && cdata[6]) {
+				goto sof;
+			} else if (!(cdata[trailer] | cdata[trailer+1] |
+				     cdata[trailer+2] | cdata[trailer+3] |
+				     cdata[trailer+5]) && cdata[trailer+6]) {
+				goto eof;
+			} else {
+				goto check_middle;
+			}
+		} else {
+			/* Check for SOF/EOF packet */
+			if ((cdata[0] | cdata[1] | cdata[2] | cdata[3] |
+			     cdata[4] | cdata[5] | cdata[6] | cdata[7]) ||
+			     (~cdata[8] & 0x08))
+				goto check_middle;
+		}
 
 		/* Frame end */
 		if (cdata[8] & 0x80) {
-			struct timeval *ts;
-
+eof:
 			ts = (struct timeval *)(frame->data + MAX_FRAME_SIZE);
 			do_gettimeofday (ts);
 
-		 	PDEBUG(4, "Frame end, curframe = %d, packnum=%d, hw=%d, vw=%d",
-				ov511->curframe, (int)(cdata[ov511->packet_size - 1]),
-				(int)(cdata[9]), (int)(cdata[10]));
+	 		PDEBUG(4, "Frame end, curframe = %d, packnum=%d, hw=%d, vw=%d, recvd=%d",
+				ov511->curframe,
+				(int)(pn ? cdata[ov511->packet_size - 1] : -1),
+				(int)(cdata[9]), (int)(cdata[10]), frame->bytes_recvd);
 
 			if (frame->scanstate == STATE_LINES) {
 		    		int iFrameNext;
 
-				if (fix_rgb_offset)
-					fixFrameRGBoffset(frame);
-				frame->grabstate = FRAME_DONE;
+				if (!ttpp) {
+					if (frame->compressed) {
+						ov511_decompress(frame);
+
+						switch (frame->format) {
+						case VIDEO_PALETTE_RGB565:
+							ov511_yuv420p_to_rgb(frame, 16);
+							break;
+						case VIDEO_PALETTE_RGB24:
+							ov511_yuv420p_to_rgb(frame, 24);
+							break;
+						case VIDEO_PALETTE_YUV420:
+						case VIDEO_PALETTE_YUV420P:
+							memmove(frame->data, frame->rawdata, MAX_RAW_DATA_SIZE);
+							break;
+						default:
+							err("Cannot convert decompressed data to this format");
+						}
+					}
+
+					if (fix_rgb_offset)
+						fixFrameRGBoffset(frame);
+				}
+
+				frame->grabstate = FRAME_DONE;	// FIXME: Is this right?
 
 				if (waitqueue_active(&frame->wq)) {
 					frame->grabstate = FRAME_DONE;
@@ -1711,6 +4345,7 @@
 			 * fixed by carlosf@conectiva.com.br
 			 */
 		} else {
+sof:
 			/* Frame start */
 			PDEBUG(4, "Frame start, framenum = %d", ov511->curframe);
 
@@ -1719,7 +4354,6 @@
 			 * for compression experimentation */
 			memset(frame->data, 0, MAX_DATA_SIZE);
 #endif
-			output_offset = 0;
 
 			/* Check to see if it's a snapshot frame */
 			/* FIXME?? Should the snapshot reset go here? Performance? */
@@ -1730,6 +4364,9 @@
 
 			frame->scanstate = STATE_LINES;
 			frame->segment = 0;
+			frame->bytes_recvd = 0;
+			frame->output_offset = 0;
+			frame->compressed = cdata[8] & 0x40;
 		}
 
 check_middle:
@@ -1737,6 +4374,25 @@
 		if (frame->scanstate != STATE_LINES)
 			continue;
 
+		/* If frame start, skip header */
+		if (frame->bytes_recvd == 0)
+			offset = 9;
+		else
+			offset = 0;
+
+		num = n - offset - (pn ? 1 : 0);
+		frame->bytes_recvd += num;
+
+		if (frame->compressed) {
+			if (frame->bytes_recvd <= MAX_RAW_DATA_SIZE)
+				memmove(frame->rawdata + frame->bytes_recvd - num,
+					&cdata[offset], num);
+			else
+				err("Raw data buffer overrun!!");
+
+			continue; /* Skip all other processing */
+		}
+
 		/* Deal with leftover from last segment, if any */
 		if (frame->segment) {
 			pData = ov511->scratch;
@@ -1744,15 +4400,16 @@
 			memmove(pData + ov511->scratchlen, cdata,
 				iPix+frame->segsize);
 		} else {
-			pData = &cdata[iPix = 9];
+			pData = &cdata[iPix = 9]; /* Start of frame */
 	 	}
 
 		/* Parse the segments */
-		while (iPix <= (ov511->packet_size - 1) - frame->segsize &&
-		    frame->segment < frame->width * frame->height / 256) {
+		while (iPix <= data_size - frame->segsize &&
+		    frame->segment < frame->width * frame->height / PIXELS_PER_SEG) {
 			int iSegY, iSegUV;
 			int iY, jY, iUV, jUV;
 			int iOutY, iOutYP, iOutUV, iOutUVP;
+			int format;
 			unsigned char *pOut;
 
 			iSegY = iSegUV = frame->segment;
@@ -1767,7 +4424,7 @@
 				iSeg1 = iSegY / (ov511->subw / 32);
 				iSeg1 *= frame->width / 32;
 				iSegY = iSeg1 + (iSegY % (ov511->subw / 32));
-				if (iSegY >= frame->width * ov511->subh / 256)
+				if (iSegY >= frame->width * ov511->subh / PIXELS_PER_SEG)
 					break;
 
 				iSeg1 = iSegUV / (ov511->subw / 16);
@@ -1792,13 +4449,20 @@
 			iOutUVP = iUV*HDIV*2*frame->width + jUV*WDIV/2;
 			iOutUV = iOutUVP * (frame->depth >> 3);
 
-			switch (frame->format) {
+			/* If ttpp is set just decode the frame to YUV420P, and
+			 * post-process it at task-time. Else, do it the old way. */
+			if (ttpp)
+				format = VIDEO_PALETTE_YUV420P;
+			else
+				format = frame->format;
+
+			switch (format) {
 			case VIDEO_PALETTE_GREY:
 				ov511_parse_data_grey (pData, pOut, iOutY, frame->width);
 				break;
 			case VIDEO_PALETTE_RGB24:
 				if (dumppix)
-					ov511_dumppix(pData, pOut, iOutY, iOutUV,
+					ov511_dumppix(frame, pData, pOut, iOutY, iOutUV,
 						iY & 1, frame->width);
 				else if (sensor_gbr)
 					ov511_parse_gbr422_to_rgb24(pData, pOut, iOutY, iOutUV,
@@ -1816,6 +4480,7 @@
 				ov511_parse_data_yuv422(pData, pOut, iOutY, iOutUV, frame->width);
 				break;
 			case VIDEO_PALETTE_YUV420:
+			case VIDEO_PALETTE_YUV420P:
 				ov511_parse_data_yuv420 (pData, pOut, iOutYP, iUV*HDIV*frame->width/2 + jUV*WDIV/4,
 					frame->width, frame->height);
 				break;
@@ -1831,8 +4496,8 @@
 		}
 
 		/* Save extra data for next time */
-		if (frame->segment < frame->width * frame->height / 256) {
-			ov511->scratchlen = (ov511->packet_size - 1) - iPix;
+		if (frame->segment < frame->width * frame->height / PIXELS_PER_SEG) {
+			ov511->scratchlen = data_size - iPix;
 			if (ov511->scratchlen < frame->segsize)
 				memmove(ov511->scratch, pData, ov511->scratchlen);
 			else
@@ -1840,9 +4505,11 @@
 		}
 	}
 
-	PDEBUG(5, "pn: %d %d %d %d %d %d %d %d %d %d",
-	       aPackNum[0], aPackNum[1], aPackNum[2], aPackNum[3], aPackNum[4],
-	       aPackNum[5],aPackNum[6], aPackNum[7], aPackNum[8], aPackNum[9]);
+	if (pn) {
+		PDEBUG(5, "pn: %d %d %d %d %d %d %d %d %d %d",
+			aPackNum[0], aPackNum[1], aPackNum[2], aPackNum[3], aPackNum[4],
+			aPackNum[5],aPackNum[6], aPackNum[7], aPackNum[8], aPackNum[9]);
+	}
 
 	return totlen;
 }
@@ -1869,9 +4536,14 @@
 		PDEBUG(4, "hmmm... not streaming, but got interrupt");
 		return;
 	}
-	
+
 	sbuf = &ov511->sbuf[ov511->cursbuf];
 
+	if (sbuf == NULL) {
+		err("null scrath buffer pointer!");
+		return;
+	}
+
 	/* Copy the data received into our scratch buffer */
 	if (ov511->curframe >= 0) {
 		len = ov511_move_data(ov511, urb);
@@ -1894,35 +4566,47 @@
 
 	PDEBUG(3, "*** Initializing capture ***");
 
-	ov511->compress = 0;
 	ov511->curframe = -1;
 	ov511->cursbuf = 0;
 	ov511->scratchlen = 0;
 
-	if (ov511->bridge == BRG_OV511)
-		if (cams == 1)			 size = 993;
-		else if (cams == 2)		 size = 513;
-		else if (cams == 3 || cams == 4) size = 257;
+	if (ov511->bridge == BRG_OV511) {
+		if (cams == 1)				size = 993;
+		else if (cams == 2)			size = 513;
+		else if (cams == 3 || cams == 4)	size = 257;
 		else {
 			err("\"cams\" parameter too high!");
 			return -1;
 		}
-	else if (ov511->bridge == BRG_OV511PLUS)
-		if (cams == 1)                      size = 961;
-		else if (cams == 2)                 size = 513;
-		else if (cams == 3 || cams == 4) size = 257;
-		else if (cams >= 5 && cams <= 8)    size = 129;
-		else if (cams >= 9 && cams <= 31)   size = 33;
+	} else if (ov511->bridge == BRG_OV511PLUS) {
+		if (cams == 1)				size = 961;
+		else if (cams == 2)			size = 513;
+		else if (cams == 3 || cams == 4)	size = 257;
+		else if (cams >= 5 && cams <= 8)	size = 129;
+		else if (cams >= 9 && cams <= 31)	size = 33;
 		else {
 			err("\"cams\" parameter too high!");
 			return -1;
 		}
-	else {
+	} else if (ov511->bridge == BRG_OV518PLUS) {
+		if (cams == 1)				size = 896;
+		else if (cams == 2)			size = 512;
+		else if (cams == 3 || cams == 4)	size = 256;
+		else if (cams >= 5 && cams <= 8)	size = 128;
+		else {
+			err("\"cams\" parameter too high!");
+			return -1;
+		}
+	} else {
 		err("invalid bridge type");
 		return -1;
 	}
 
-	ov511_set_packet_size(ov511, size);
+	// FIXME: OV518 is hardcoded to 15 FPS (alternate 5) for now
+	if (ov511->bridge == BRG_OV518PLUS)
+		ov511_set_packet_size(ov511, 640);
+	else
+		ov511_set_packet_size(ov511, size);
 
 	for (n = 0; n < OV511_NUMSBUF; n++) {
 		urb = usb_alloc_urb(FRAMES_PER_DESC);
@@ -2053,9 +4737,17 @@
 	if (!ov511->fbuf)
 		goto error;
 
+	ov511->rawfbuf = vmalloc(OV511_NUMFRAMES * MAX_RAW_DATA_SIZE);
+	if (!ov511->rawfbuf) {
+		rvfree(ov511->fbuf, OV511_NUMFRAMES * MAX_DATA_SIZE);
+		ov511->fbuf = NULL;
+		goto error;
+	}
+
 	for (i = 0; i < OV511_NUMFRAMES; i++) {
 		ov511->frame[i].grabstate = FRAME_UNUSED;
 		ov511->frame[i].data = ov511->fbuf + i * MAX_DATA_SIZE;
+		ov511->frame[i].rawdata = ov511->rawfbuf + i * MAX_RAW_DATA_SIZE;
 		PDEBUG(4, "frame[%d] @ %p", i, ov511->frame[i].data);
 
 		ov511->sbuf[i].data = kmalloc(FRAMES_PER_DESC *
@@ -2064,7 +4756,11 @@
 			while (--i) {
 				kfree(ov511->sbuf[i].data);
 				ov511->sbuf[i].data = NULL;
+				ov511->frame[i].data = NULL;
+				ov511->frame[i].rawdata = NULL;
 			}
+			vfree(ov511->rawfbuf);
+			ov511->rawfbuf = NULL;
 			rvfree(ov511->fbuf, OV511_NUMFRAMES * MAX_DATA_SIZE);
 			ov511->fbuf = NULL;
 			goto error;
@@ -2098,11 +4794,22 @@
 		ov511->fbuf = NULL;
 	}
 
+	if (ov511->rawfbuf) {
+		vfree(ov511->rawfbuf);
+		ov511->rawfbuf = NULL;
+	}
+
 	for (i = 0; i < OV511_NUMFRAMES; i++) {
 		if (ov511->sbuf[i].data) {
 			kfree(ov511->sbuf[i].data);
 			ov511->sbuf[i].data = NULL;
 		}
+		ov511->frame[i].data = NULL;
+		ov511->frame[i].rawdata = NULL;
+
+		/* Allocated by decompressor */
+		FREE(ov511->frame[i].m_pTempBuffer);
+		ov511->frame[i].m_pTempBuffer = NULL;
 	}
 
 	PDEBUG(4, "buffer memory deallocated");
@@ -2182,6 +4889,9 @@
 	}
 
 	ov511->user++;
+	
+	if (ov511->led_policy == LED_AUTO)
+		ov511_led_control(ov511, 1);
 
 out:
 	up(&ov511->lock);
@@ -2203,6 +4913,9 @@
 	ov511->user--;
 	ov511_stop_isoc(ov511);
 
+	if (ov511->led_policy == LED_AUTO)
+		ov511_led_control(ov511, 0);
+
 	if (ov511->dev)
 		ov511_dealloc(ov511, 0);
 
@@ -2274,6 +4987,7 @@
 		v.flags = 0;
 		v.tuners = 0;
 		v.type = VIDEO_TYPE_CAMERA;
+		v.norm = 0;
 		strcpy(v.name, "Camera");
 
 		if (copy_to_user(arg, &v, sizeof(v)))
@@ -2400,7 +5114,7 @@
 		interruptible_sleep_on(&ov511->wq);
 		if (signal_pending(current)) return -EINTR;
 
-		result = ov511_mode_init_regs(ov511, vw.width, vw.height,
+		result = mode_init_regs(ov511, vw.width, vw.height,
 			ov511->frame[0].format, ov511->sub_flag);
 		if (result < 0)
 			return result;
@@ -2476,7 +5190,6 @@
 		if (ov511->frame[vm.frame].grabstate == FRAME_GRABBING)
 			return -EBUSY;
 
-		/* Don't compress if the size changed */
 		if ((ov511->frame[vm.frame].width != vm.width) ||
 		    (ov511->frame[vm.frame].height != vm.height) ||
 		    (ov511->frame[vm.frame].format != vm.format) ||
@@ -2486,7 +5199,7 @@
 			   before changing modes */
 			interruptible_sleep_on(&ov511->wq);
 			if (signal_pending(current)) return -EINTR;
-			ret = ov511_mode_init_regs(ov511, vm.width, vm.height,
+			ret = mode_init_regs(ov511, vm.width, vm.height,
 				vm.format, ov511->sub_flag);
 #if 0
 			if (ret < 0)
@@ -2572,10 +5285,12 @@
 			if ((ov511->snap_enabled) &&
 			    (ov511->frame[frame].snapshot)) {
 				ov511->frame[frame].snapshot = 0;
-				ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x01);
-				ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x03);
-				ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x01);
+				ov51x_clear_snapshot(ov511);
 			}
+
+			if (ttpp)
+				ov511_postprocess(&(ov511->frame[frame]));
+
 			break;
 		} /* end switch */
 
@@ -2615,7 +5330,7 @@
 	return 0;
 }
 
-static long ov511_read(struct video_device *dev, char *buf, unsigned long count, int noblock)
+static inline long ov511_read(struct video_device *dev, char *buf, unsigned long count, int noblock)
 {
 	struct usb_ov511 *ov511 = (struct usb_ov511 *)dev;
 	int i;
@@ -2688,13 +5403,14 @@
 	}
 
 	/* Clear the snapshot */
-	if (ov511->snap_enabled && frame->snapshot) {
-		frame->snapshot = 0;
-		ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x01);
-		ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x03);
-		ov511_reg_write(ov511->dev, OV511_REG_SYSTEM_SNAPSHOT, 0x01);
+	if (ov511->snap_enabled && frame->snapshot) {
+		frame->snapshot = 0;
+		ov51x_clear_snapshot(ov511);
 	}
 
+	if (ttpp)
+		ov511_postprocess((struct ov511_frame *) frame);
+
 	PDEBUG(4, "frmx=%d, bytes_read=%ld, scanlength=%ld", frmx,
 		frame->bytes_read, frame->scanlength);
 
@@ -2775,11 +5491,14 @@
 
 /****************************************************************************
  *
- * OV511/OV7610 configuration
+ * OV511 and sensor configuration
  *
  ***************************************************************************/
 
-static int ov76xx_configure(struct usb_ov511 *ov511)
+/* This initializes the OV7610, OV7620, or OV7620AE sensor. The OV7620AE uses
+ * the same register settings as the OV7610, since they are very similar.
+ */
+static int ov7xx0_configure(struct usb_ov511 *ov511)
 {
 	struct usb_device *dev = ov511->dev;
 	int i, success;
@@ -2855,40 +5574,12 @@
 	PDEBUG (4, "starting configuration");
 
 	/* This looks redundant, but is necessary for WebCam 3 */
-	if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_WRITE,
-	                    OV7610_I2C_WRITE_ID) < 0)
-		return -1;
-
-	if (ov511_reg_write(dev, OV511_REG_I2C_SLAVE_ID_READ,
-	                    OV7610_I2C_READ_ID) < 0)
-		return -1;
-
-	if (ov511_reset(dev, OV511_RESET_NOREGS) < 0)
+	if (ov51x_set_slave_ids(ov511, OV7xx0_I2C_WRITE_ID,
+				OV7xx0_I2C_READ_ID) < 0)
 		return -1;
 
-	/* Reset the 76xx */ 
-	if (ov511_i2c_write(dev, 0x12, 0x80) < 0) return -1;
-
-	/* Wait for it to initialize */ 
-	schedule_timeout (1 + 150 * HZ / 1000);
-
-	for (i = 0, success = 0; i < i2c_detect_tries && !success; i++) {
-		if ((ov511_i2c_read(dev, OV7610_REG_ID_HIGH) == 0x7F) &&
-		    (ov511_i2c_read(dev, OV7610_REG_ID_LOW) == 0xA2)) {
-			success = 1;
-			continue;
-		}
-
-		/* Reset the 76xx */ 
-		if (ov511_i2c_write(dev, 0x12, 0x80) < 0) return -1;
-		/* Wait for it to initialize */ 
-		schedule_timeout (1 + 150 * HZ / 1000);
-		/* Dummy read to sync I2C */
-		if (ov511_i2c_read(dev, 0x00) < 0) return -1;
-	}
-
-	if (success) {
-		PDEBUG(1, "I2C synced in %d attempt(s) (method 1)", i);
+	if (ov51x_init_ov_sensor(ov511) >= 0) {
+		PDEBUG(1, "OV7xx0 sensor initalized (method 1)");
 	} else {
 		/* Reset the 76xx */
 		if (ov511_i2c_write(dev, 0x12, 0x80) < 0) return -1;
@@ -2908,13 +5599,16 @@
 			}
 		}
 
-		if ((i == i2c_detect_tries) && (success == 0)) {
+// Was (i == i2c_detect_tries) previously. This obviously used to always report
+// success. Whether anyone actually depended on that bug is unknown
+		if ((i >= i2c_detect_tries) && (success == 0)) {
 			err("Failed to read sensor ID. You might not have an OV7610/20,");
-			err("or it may be not responding. Report this to");
-			err("mwm@i.am");
-			return -1;
+			err("or it may be not responding. Report this to mmcclell@bigfoot.com");
+			err("This is only a warning. You can attempt to use your camera anyway");
+// Only issue a warning for now  
+//			return -1;
 		} else {
-			PDEBUG(1, "I2C synced in %d attempt(s) (method 2)", i+1);
+			PDEBUG(1, "OV7xx0 initialized in %d attempt(s) (method 2)", i+1);
 		}
 	}
 
@@ -2929,8 +5623,22 @@
 			info("Sensor is an OV7610");
 			ov511->sensor = SEN_OV7610;
 		} else if((rc & 3) == 1) {
-			info("Sensor is an OV7620AE");
-			ov511->sensor = SEN_OV7620AE;
+			
+			/* I don't know what's different about the 76BE yet */
+			if (ov511_i2c_read(dev, 0x15) & 1)
+				info("Sensor is an OV7620AE");
+			else
+				info("Sensor is an OV76BE");
+
+			/* OV511+ will return all zero isoc data unless we
+			 * configure the sensor as a 7620. Someone needs to
+			 * find the exact reg. setting that causes this. */
+			if (ov511->bridge == BRG_OV511PLUS) {
+				info("Enabling 511+/7620AE workaround");
+				ov511->sensor = SEN_OV7620;
+			} else {
+				ov511->sensor = SEN_OV7620AE;
+			}
 		} else if((rc & 3) == 0) {
 			info("Sensor is an OV7620");
 			ov511->sensor = SEN_OV7620;
@@ -2981,74 +5689,138 @@
 	return 0;
 }
 
+/* This initializes the OV6620, OV6630, OV6630AE, or OV6630AF sensor. */
 static int ov6xx0_configure(struct usb_ov511 *ov511)
 {
 	struct usb_device *dev = ov511->dev;
-	int i, success, rc;
+	int rc;
 
 	static struct ov511_regvals aRegvalsNorm6x20[] = {
-		{ OV511_I2C_BUS, 0x12, 0x80 },  /* reset */
+		{ OV511_I2C_BUS, 0x12, 0x80 }, /* reset */
 		{ OV511_I2C_BUS, 0x11, 0x01 },
-		{ OV511_I2C_BUS, 0x03, 0xd0 },
-		{ OV511_I2C_BUS, 0x05, 0x7f },
+		{ OV511_I2C_BUS, 0x03, 0x60 },
+		{ OV511_I2C_BUS, 0x05, 0x7f }, /* For when autoadjust is off */
 		{ OV511_I2C_BUS, 0x07, 0xa8 },
+		/* The ratio of 0x0c and 0x0d  controls the white point */
 		{ OV511_I2C_BUS, 0x0c, 0x24 },
 		{ OV511_I2C_BUS, 0x0d, 0x24 },
-		{ OV511_I2C_BUS, 0x10, 0xff },  /* ? */
+		{ OV511_I2C_BUS, 0x12, 0x28 }, /* Enable AGC */
 		{ OV511_I2C_BUS, 0x14, 0x04 },
-		{ OV511_I2C_BUS, 0x16, 0x06 },  /* ? */
-		{ OV511_I2C_BUS, 0x19, 0x04 },
-		{ OV511_I2C_BUS, 0x1a, 0x93 },
-		{ OV511_I2C_BUS, 0x20, 0x28 },
-		{ OV511_I2C_BUS, 0x27, 0xa2 },
-		{ OV511_I2C_BUS, 0x28, 0x24 },
-		{ OV511_I2C_BUS, 0x2a, 0x04 },  /* 84? */
-		{ OV511_I2C_BUS, 0x2b, 0xac },  /* a8? */
-		{ OV511_I2C_BUS, 0x2d, 0x95 },
-		{ OV511_I2C_BUS, 0x33, 0x28 },
-		{ OV511_I2C_BUS, 0x34, 0xc7 },
+		/* 0x16: 0x06 helps frame stability with moving objects */
+		{ OV511_I2C_BUS, 0x16, 0x06 },
+//		{ OV511_I2C_BUS, 0x20, 0x30 }, /* Aperture correction enable */
+		{ OV511_I2C_BUS, 0x26, 0xb2 }, /* BLC enable */
+		{ OV511_I2C_BUS, 0x28, 0x05 }, /* Selects RGB format if RGB on */
+		{ OV511_I2C_BUS, 0x2a, 0x04 }, /* Disable framerate adjust */
+//		{ OV511_I2C_BUS, 0x2b, 0xac }, /* Framerate; Set 2a[7] first */
+		{ OV511_I2C_BUS, 0x34, 0xd2 }, /* Max A/D range */
 		{ OV511_I2C_BUS, 0x38, 0x8b },
-		{ OV511_I2C_BUS, 0x3c, 0x5c },
+		{ OV511_I2C_BUS, 0x39, 0x40 },
+		
+		{ OV511_I2C_BUS, 0x3c, 0x39 }, /* Enable AEC mode changing */
+		{ OV511_I2C_BUS, 0x3c, 0x3c }, /* Change AEC mode */
+		{ OV511_I2C_BUS, 0x3c, 0x24 }, /* Disable AEC mode changing */
+
 		{ OV511_I2C_BUS, 0x3d, 0x80 },
-		{ OV511_I2C_BUS, 0x3f, 0x00 },
-		{ OV511_I2C_BUS, 0x4a, 0x80 }, /* undocumented */
-		{ OV511_I2C_BUS, 0x4b, 0x80 }, /* undocumented */
-		{ OV511_I2C_BUS, 0x4d, 0xd2 },
+		/* These next two registers (0x4a, 0x4b) are undocumented. They 
+		 * control the color balance */
+		{ OV511_I2C_BUS, 0x4a, 0x80 },
+		{ OV511_I2C_BUS, 0x4b, 0x80 },
+		{ OV511_I2C_BUS, 0x4d, 0xd2 }, /* This reduces noise a bit */
 		{ OV511_I2C_BUS, 0x4e, 0xc1 },
 		{ OV511_I2C_BUS, 0x4f, 0x04 },
+// Do 50-53 have any effect?
+// Toggle 0x12[2] off and on here?
+		{ OV511_DONE_BUS, 0x0, 0x00 },
+	};
+
+	/* This chip is undocumented so many of these are guesses. OK=verified,
+	 * A=Added since 6620, U=unknown function (not a 6620 reg) */
+	static struct ov511_regvals aRegvalsNorm6x30[] = {
+	/*OK*/	{ OV511_I2C_BUS, 0x12, 0x80 }, /* reset */
+	/*00?*/	{ OV511_I2C_BUS, 0x11, 0x01 },
+	/*OK*/	{ OV511_I2C_BUS, 0x03, 0x60 },
+	/*0A?*/	{ OV511_I2C_BUS, 0x05, 0x7f }, /* For when autoadjust is off */
+		{ OV511_I2C_BUS, 0x07, 0xa8 },
+		/* The ratio of 0x0c and 0x0d  controls the white point */
+	/*OK*/	{ OV511_I2C_BUS, 0x0c, 0x24 },
+	/*OK*/	{ OV511_I2C_BUS, 0x0d, 0x24 },
+	/*A*/	{ OV511_I2C_BUS, 0x0e, 0x20 },
+//	/*24?*/	{ OV511_I2C_BUS, 0x12, 0x28 }, /* Enable AGC */
+//		{ OV511_I2C_BUS, 0x12, 0x24 }, /* Enable AGC */
+//	/*A*/	{ OV511_I2C_BUS, 0x13, 0x21 },
+//	/*04?*/	{ OV511_I2C_BUS, 0x14, 0x80 },
+		/* 0x16: 0x06 helps frame stability with moving objects */
+	/*03?*/	{ OV511_I2C_BUS, 0x16, 0x06 },
+//	/*OK*/	{ OV511_I2C_BUS, 0x20, 0x30 }, /* Aperture correction enable */
+		// 21 & 22? The suggested values look wrong. Go with default
+	/*A*/	{ OV511_I2C_BUS, 0x23, 0xc0 },
+	/*A*/	{ OV511_I2C_BUS, 0x25, 0x9a }, // Check this against default
+//	/*OK*/	{ OV511_I2C_BUS, 0x26, 0xb2 }, /* BLC enable */
+//	/*04?*/	{ OV511_I2C_BUS, 0x28, 0x05 }, /* Selects RGB format if RGB on */
+	/*OK*/	{ OV511_I2C_BUS, 0x2a, 0x04 }, /* Disable framerate adjust */
+//	/*OK*/	{ OV511_I2C_BUS, 0x2b, 0xac }, /* Framerate; Set 2a[7] first */
+//	/*U*/	{ OV511_I2C_BUS, 0x2c, 0xa0 },
+//	/*A*/	{ OV511_I2C_BUS, 0x33, 0x26 }, // Reserved bits on 6620
+		// Reg 0x34: More 6620 reserved junk
+//	/*d2?*/	{ OV511_I2C_BUS, 0x34, 0x03 }, /* Max A/D range */
+//	/*U*/	{ OV511_I2C_BUS, 0x36, 0x8f }, // May not be necessary
+//	/*U*/	{ OV511_I2C_BUS, 0x37, 0x80 }, // May not be necessary
+//	/*8b?*/	{ OV511_I2C_BUS, 0x38, 0x83 },
+//	/*40?*/	{ OV511_I2C_BUS, 0x39, 0xc0 }, // 6630 adds bit 7
+		//Check these again
+//		{ OV511_I2C_BUS, 0x3c, 0x39 }, /* Enable AEC mode changing */
+//		{ OV511_I2C_BUS, 0x3c, 0x3c }, /* Change AEC mode */
+//		{ OV511_I2C_BUS, 0x3c, 0x24 }, /* Disable AEC mode changing */
+
+	/*OK*/	{ OV511_I2C_BUS, 0x3d, 0x80 },
+//	/*A*/	{ OV511_I2C_BUS, 0x3f, 0x0e }, // Reserved bits on 6620. Default may be safer.
+
+//	/*U*/	{ OV511_I2C_BUS, 0x40, 0x00 },
+//	/*U*/	{ OV511_I2C_BUS, 0x41, 0x00 },
+//	/*U*/	{ OV511_I2C_BUS, 0x42, 0x80 },
+//	/*U*/	{ OV511_I2C_BUS, 0x43, 0x3f },
+//	/*U*/	{ OV511_I2C_BUS, 0x44, 0x80 },
+//	/*U*/	{ OV511_I2C_BUS, 0x45, 0x20 },
+//	/*U*/	{ OV511_I2C_BUS, 0x46, 0x20 },
+//	/*U*/	{ OV511_I2C_BUS, 0x47, 0x80 },
+//	/*U*/	{ OV511_I2C_BUS, 0x48, 0x7f },
+//	/*U*/	{ OV511_I2C_BUS, 0x49, 0x00 },
+
+		/* These next two registers (0x4a, 0x4b) are undocumented. They 
+		 * control the color balance */
+//	/*OK?*/	{ OV511_I2C_BUS, 0x4a, 0x80 }, // Check these
+//	/*OK?*/	{ OV511_I2C_BUS, 0x4b, 0x80 },
+//	/*U*/	{ OV511_I2C_BUS, 0x4c, 0xd0 }, // These high registers are always suspect
+	/*d2?*/	{ OV511_I2C_BUS, 0x4d, 0x10 }, /* This reduces noise a bit */
+	/*c1?*/	{ OV511_I2C_BUS, 0x4e, 0x40 },
+	/*04?*/	{ OV511_I2C_BUS, 0x4f, 0x07 },
+
+//	/*U*/	{ OV511_I2C_BUS, 0x50, 0xff }, // These are all undocumented (by 6620 docs)
+	/*U*/	{ OV511_I2C_BUS, 0x54, 0x23 },
+//	/*U*/	{ OV511_I2C_BUS, 0x55, 0xff },
+//	/*U*/	{ OV511_I2C_BUS, 0x56, 0x12 },
+	/*U*/	{ OV511_I2C_BUS, 0x57, 0x81 },
+//	/*U*/	{ OV511_I2C_BUS, 0x58, 0x75 },
+	/*U*/	{ OV511_I2C_BUS, 0x59, 0x01 },
+	/*U*/	{ OV511_I2C_BUS, 0x5a, 0x2c },
+	/*U*/	{ OV511_I2C_BUS, 0x5b, 0x0f },
+//	/*U*/	{ OV511_I2C_BUS, 0x5c, 0x10 },
+
+// Set 0x3d to 0x80 here?
+// Set 0x27 to 0xa6 here?
+// Toggle 0x12[2] off and on here?
 		{ OV511_DONE_BUS, 0x0, 0x00 },
 	};
 
 	PDEBUG (4, "starting sensor configuration");
 	
-	/* Reset the 6xx0 */ 
-	if (ov511_i2c_write(dev, 0x12, 0x80) < 0) return -1;
-
-	/* Wait for it to initialize */ 
-	schedule_timeout (1 + 150 * HZ / 1000);
-
-	for (i = 0, success = 0; i < i2c_detect_tries && !success; i++) {
-		if ((ov511_i2c_read(dev, OV7610_REG_ID_HIGH) == 0x7F) &&
-		    (ov511_i2c_read(dev, OV7610_REG_ID_LOW) == 0xA2)) {
-			success = 1;
-			continue;
-		}
-
-		/* Reset the 6xx0 */ 
-		if (ov511_i2c_write(dev, 0x12, 0x80) < 0) return -1;
-		/* Wait for it to initialize */ 
-		schedule_timeout (1 + 150 * HZ / 1000);
-		/* Dummy read to sync I2C */
-		if (ov511_i2c_read(dev, 0x00) < 0) return -1;
-	}
-
-	if (success) {
-		PDEBUG(1, "I2C synced in %d attempt(s)", i);
-	} else {
+	if (ov51x_init_ov_sensor(ov511) < 0) {
 		err("Failed to read sensor ID. You might not have an OV6xx0,");
-		err("or it may be not responding. Report this to");
-		err("mwm@i.am");
+		err("or it may be not responding. Report this to mmcclell@bigfoot.com");
 		return -1;
+	} else {
+		PDEBUG(1, "OV6xx0 sensor detected");
 	}
 
 	/* Detect sensor if user didn't use override param */
@@ -3058,10 +5830,19 @@
 		if (rc < 0) {
 			err("Error detecting sensor type");
 			return -1;
-		} else {
-			info("Sensor is an OV6xx0 (version %d)", rc & 3);
+		} else if((rc & 3) == 0) {
+			info("Sensor is an OV6630");
+			ov511->sensor = SEN_OV6630;
+		} else if((rc & 3) == 1) {
+			info("Sensor is an OV6620");
 			ov511->sensor = SEN_OV6620;
-		}
+		} else if((rc & 3) == 2) {
+			info("Sensor is an OV6630AE");
+			ov511->sensor = SEN_OV6630;
+		} else if((rc & 3) == 3) {
+			info("Sensor is an OV6630AF");
+			ov511->sensor = SEN_OV6630;
+		} 
 	} else {	/* sensor != 0; user overrode detection */
 		ov511->sensor = sensor;
 		info("Sensor set to type %d", ov511->sensor);
@@ -3071,10 +5852,16 @@
 	ov511->maxwidth = 352;
 	ov511->maxheight = 288;
 
-	PDEBUG(4, "Writing 6x20 registers");
-	if (ov511_write_regvals(dev, aRegvalsNorm6x20))
-		return -1;
-
+	if (ov511->sensor == SEN_OV6620) {
+		PDEBUG(4, "Writing 6x20 registers");
+		if (ov511_write_regvals(dev, aRegvalsNorm6x20))
+			return -1;
+	} else {
+		PDEBUG(4, "Writing 6x30 registers");
+		if (ov511_write_regvals(dev, aRegvalsNorm6x30))
+			return -1;
+	}
+	
 	if (aperture < 0) {          /* go with the default */
 		if (ov511_i2c_write(dev, 0x26, 0xa2) < 0) return -1;
 	} else if (aperture <= 0xf) {  /* user overrode default */
@@ -3086,26 +5873,24 @@
 	}
 
 	if (autoadjust) {
-		if (ov511_i2c_write(dev, 0x13, 0x01) < 0) return -1;
-		if (ov511_i2c_write(dev, 0x2d, 
-		     ov511->sensor==SEN_OV7620?0x91:0x93) < 0) return -1;
+		if (ov511_i2c_write_mask(dev, 0x13, 0x01, 0x01) < 0) return -1;
+		if (ov511_i2c_write(dev, 0x2d, 0x99) < 0) return -1;
 	} else {
-		if (ov511_i2c_write(dev, 0x13, 0x00) < 0) return -1;
-		if (ov511_i2c_write(dev, 0x2d, 
-		     ov511->sensor==SEN_OV7620?0x81:0x83) < 0) return -1;
-		ov511_i2c_write(dev, 0x28, ov511_i2c_read(dev, 0x28) | 8);
+		if (ov511_i2c_write_mask(dev, 0x13, 0x00, 0x01) < 0) return -1;
+		if (ov511_i2c_write(dev, 0x2d, 0x89) < 0) return -1;
+		if (ov511_i2c_write_mask(dev, 0x28, 0x08, 0x08) < 0) return -1;
 	}
 
 	return 0;
 }
 
-
+/* This initializes the OV511/OV511+ and the sensor */
 static int ov511_configure(struct usb_ov511 *ov511)
 {
 	struct usb_device *dev = ov511->dev;
 	int i;
 
-	static struct ov511_regvals aRegvalsInit[] = {
+	static struct ov511_regvals aRegvalsInit511[] = {
 		{ OV511_REG_BUS, OV511_REG_SYSTEM_RESET, 0x7f },
 	 	{ OV511_REG_BUS, OV511_REG_SYSTEM_INIT, 0x01 },
 	 	{ OV511_REG_BUS, OV511_REG_SYSTEM_RESET, 0x7f },
@@ -3118,22 +5903,46 @@
 
 	static struct ov511_regvals aRegvalsNorm511[] = {
 		{ OV511_REG_BUS, OV511_REG_DRAM_ENABLE_FLOW_CONTROL, 0x01 },
-		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x02 },
-		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x00 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x01 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x03 },
+		{ OV511_REG_BUS, OV511_REG_SYSTEM_SNAPSHOT, 0x01 },
 		{ OV511_REG_BUS, OV511_REG_FIFO_BITMASK, 0x1f },
-		{ OV511_REG_BUS, OV511_OMNICE_PREDICTION_HORIZ_Y, 0x08 },
-		{ OV511_REG_BUS, OV511_OMNICE_PREDICTION_HORIZ_UV, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_PREDICTION_VERT_Y, 0x08 },
-		{ OV511_REG_BUS, OV511_OMNICE_PREDICTION_VERT_UV, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_QUANTIZATION_HORIZ_Y, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_QUANTIZATION_HORIZ_UV, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_QUANTIZATION_VERT_Y, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_QUANTIZATION_VERT_UV, 0x01 },
-		{ OV511_REG_BUS, OV511_OMNICE_ENABLE, 0x06 },
+		{ OV511_REG_BUS, OV511_OMNICE_ENABLE, 0x00 },
 		{ OV511_REG_BUS, OV511_OMNICE_LUT_ENABLE, 0x03 },
 		{ OV511_DONE_BUS, 0x0, 0x00 },
 	};
 
+	PDEBUG(4, "");
+
+	ov511->customid = ov511_reg_read(dev, OV511_REG_SYSTEM_CUSTOM_ID);
+	if (ov511->customid < 0) {
+		err("Unable to read camera bridge registers");
+		return -EIO;
+	}
+
+	ov511->desc = -1;
+	PDEBUG (4, "CustomID = %d", ov511->customid);
+	for (i = 0; clist[i].id >= 0; i++) {
+		if (ov511->customid == clist[i].id) {
+			info("camera: %s", clist[i].description);
+			ov511->desc = i;
+			break;
+		}
+	}
+
+	/* Lifeview USB Life TV not supported */
+	if (clist[i].id == 38) {
+		err("This device is not supported yet.");
+		return -EIO;
+	}
+
+	if (clist[i].id == -1) {
+		err("Camera type (%d) not recognized", ov511->customid);
+		err("Please notify mmcclell@bigfoot.com of the name, manufacturer, model,");
+		err("and camera type number of your camera. Also include the");
+		err("complete output of the detection process.");
+	}
+
 	memcpy(&ov511->vdev, &ov511_template, sizeof(ov511_template));
 
 	for (i = 0; i < OV511_NUMFRAMES; i++)
